//
//      InformationWindow.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.5
//

#ifndef __INFORMATIONWINDOW_HPP
#define __INFORMATIONWINDOW_HPP

#include <SophiaFramework.hpp>
#include "SGRErrorDialogSet.hpp"
#include "SAXParser.hpp"



SFMRESPONDERBEHAVIOR(LINKLABEL, BEHAVIOR_SFRCONTROL, PROPERTY_DIRECT,  APPEARANCE_TRANSPARENT)
SFMTYPEDEFCLASS(LinkLabel)
class LinkLabel : public SFRButtonBase {
private:
    SFXWideString _title;
public:
    LinkLabel(SFRResponderPtr, SFXRectangleConstRef, SFXWideStringConstRef, BehaviorType = BEHAVIOR_LINKLABEL);
    ~LinkLabel(Void);
    Void SetTitle(SFXWideStringConstRef);
    SFXWideStringConstRef GetTitle(Void) const;
private:
    virtual Void HandleRelease(Void);
    virtual Void HandleContent(SFXGraphicsPtr);	

};

SFMTYPEDEFCLASS(ScrollTabPane)
class ScrollTabPane : public SFRTabPane {
    SFMSEALCOPY(ScrollTabPane)
public:
    ScrollTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title);
    Void SetHeight(SInt16 height);
private:
    HANDLER_DECLARE_BOOLEVENT(OnKey)
    HANDLER_DECLARE_VOIDRENDER(OnRender)
};

SFMTYPEDEFCLASS(AWSTabPane)
class AWSTabPane : public ScrollTabPane {
    SFMSEALCOPY(AWSTabPane)
private:
    SFXAnsiString _string;
    SFXProperty _value;
    UInt16 _maxWidth;
public:
    AWSTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title);
    virtual ~AWSTabPane(Void);
    SFCError MakeLabels(Void);
    SFCError Append(SFXAnsiStringConstRef name, SFXAnsiStringConstRef value);
    SFCError Append(SFXAnsiStringConstRef name, SInt32 value);
    Void Clear(Void);
private:
    HANDLER_DECLARE_VOIDCONTROL(OnLink)
};

SFMTYPEDEFCLASS(AWSReviewTabPane)
class AWSReviewTabPane : public ScrollTabPane {
    SFMSEALCOPY(AWSReviewTabPane)
private:
    SAXParserPtr _parser;
public:
    AWSReviewTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title, SAXParserPtr parser) static_throws;
    SFCError MakeLabels(Void);
};

SFMTYPEDEFCLASS(AWSImageTabPane)
class AWSImageTabPane : public ScrollTabPane {
    SFMSEALCOPY(AWSImageTabPane)
private:
    SFXHTTPConnection _http;
    SFXBinaryStreamReader _reader;
    SFXAnsiString _url;
    SFXAnsiString _asin;
    SFXBuffer _imageBuffer;
    SFBImageSmp _image;

public:
    AWSImageTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title, SFXAnsiStringConstRef url, SFXAnsiStringConstRef asin);
    virtual ~AWSImageTabPane(Void);

private:
    Void ProceedNetworkError(Void);
    HANDLER_DECLARE_VOIDRENDER(OnRenderContent)
    HANDLER_DECLARE_VOIDCONTROL(OnButtonControl)

    // HTTP ڑJñR[obN
    CALLBACK_DECLARE_SFXHTTPCONNECTION(ConnectCallback)
    // HTTP MR[obN
    CALLBACK_DECLARE_SFXBINARYSTREAMREADER(FetchCallback)
};

SFMRESPONDERATTRIBUTE(INFORMATIONWINDOW, four_char_code('I', 'n', 'f', 'o'))

SFMTYPEDEFCLASS(InformationWindow)
class InformationWindow : public SFRPlainWindow {
    SFMSEALCOPY(InformationWindow)
private:
    enum {
        OPERATION_BBS,
        OPERATION_BUY,
        OPERATION_LIMIT
    };

    SAXParserPtr _parser;
	SFXAnsiString _temp;
	SGRErrorDialogSet _errorDialog;

public:
    explicit InformationWindow(SAXParserPtr parser) static_throws;
    virtual ~InformationWindow(Void);

private:
    HANDLER_DECLARE_BOOLEVENT(OnKey)
    HANDLER_DECLARE_VOIDEVENT(OnSoftkey)
    HANDLER_DECLARE_VOIDMENU(FromSoftkey2)
    SFCError MakeDialog(Void);
    SFCError MakeGeneralPane(SFRTabControlPtr tab);
    SFCError MakeDetailPane(SFRTabControlPtr tab);
    SFCError MakeSimilarPane(SFRTabControlPtr tab);
	SFXAnsiStringRef UTF8ToShiftJIS(SFXAnsiStringConstRef);

};

#endif // __INFORMATIONWINDOW_HPP //
